/*
 Copyright 2016 Goldman Sachs.
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing,
 software distributed under the License is distributed on an
 "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 KIND, either express or implied.  See the License for the
 specific language governing permissions and limitations
 under the License.
 */

package com.gs.fw.common.mithra.finder.integer;

import com.gs.fw.common.mithra.finder.ResultSetParser;

import java.sql.ResultSet;
import java.sql.SQLException;



public class IntegerResultSetParserWithNullChecking  implements ResultSetParser
{

    public Object parseResult(ResultSet rs) throws SQLException
    {
        int value = rs.getInt(1);
        Integer returnValue = null;
        if(!rs.wasNull())
        {
            returnValue = Integer.valueOf(value);
        }
        return returnValue;
    }
}
